<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html;
      charset=windows-1252">
    <title>iFit: Welcome</title>
  </head>
  <body>
    <h1 style="text-align: center;"><a class="mozTocH1"
        name="mozTocId294096"></a>iFit: a simple library to analyze data</h1>
    <div style="text-align: center;">E. Farhi <span style="font-style:
        italic;">- Version <span style="font-weight: bold;">@IFIT_VERSION@

          - @IFIT_DATE@</span></span><br>
      <a href="http://ifit.mccode.org"><img alt="iFit" title="iFit"
          src="images/iFit-logo.png" height="64" width="116" border="0"></a><br>
    </div>
    <ul id="mozToc">
      <!--mozToc h3 1 h4 2 h3 3 h4 4 h5 5 h6 6-->
      <li><a href="#mozTocId127491">Purpose</a></li>
      <li><a href="#mozTocId969915">Main functionalities</a></li>
      <li><a href="#mozTocId755938">Ok, let's start ! </a></li>
      <li><a href="#mozTocId639966">For beginners</a></li>
      <li><a href="#mozTocId66420">Help me !</a></li>
      <li><b><a href="#mozTocId318588">Obtaining the package</a></b></li>
      <li><a href="#mozTocId93435">Credits, Links and Disclaimer </a></li>
    </ul>
    <hr style="width: 100%; height: 2px;">
    <div style="text-align: center;"><br>
      <span style="font-style: italic; font-weight: bold;">Welcome to
        the iFit Data Analysis library !</span><br>
      &lt;<a href="http://ifit.mccode.org">ifit.mccode.org</a>&gt;<br>
      <br>
      <span style="font-style: italic;">"Simple methods to be used for
        complex data analysis"</span><br>
      <br>
      <span style="font-style: italic;">Main functionalities are</span><br>
      [ <a href="iData.html">iData</a> <a href="Load.html">Load</a> <a
        href="Plot.html">Plot</a> <a href="Math.html">Math</a> <a
        href="Fit.html">Fit</a> <a href="Save.html">Save</a> <a
        href="Optimizers.html">Optimization</a> <a href="iFunc.html">iFunc</a>
      <a href="Models.html">Models</a> <a href="Loaders.html">File
        formats</a>]<br>
      [ <a href="miFit.html">miFit</a> <a href="Python.html">PyFit</a>
      <a href="Models_Phonons.html"> Phonons</a> <a
        href="../Applications/ResLibCal/doc/ResLibCal.html">ResLibCal</a>
      <a href="McStas.html">McStas</a> <a
        href="Neutron_Scattering.html">Neutron Scattering</a> ]<br>
      <br>
      <div style="text-align: left;">
        <h3><a class="mozTocH3" name="mozTocId127491"></a>Purpose</h3>
        The <span style="font-style: italic; font-weight: bold;">iFit</span>
        library (pronounce [<span style="font-style: italic;">eye-fit</span>])









        is a set of methods to load, analyze, plot, fit and optimize
        scientific data sets and models, and export results. <span
          style="font-style: italic;">iFit</span> is based on <a
          href="http://www.mathworks.com">Matlab</a>, but can also be
        launched without Matlab license (stand-alone version).<a
          href="http://www.mathworks.com"><img alt="Matlab"
            title="Matlab" src="images/ml_icon.gif" style="border: 0px
            solid ; width: 45px; height: 38px;" align="right"></a> The
        library focuses on <span style="font-style: italic;">doing the
          math right</span>. Any text file can be imported straight
        away, and a large set of binary files are supported. Any data
        dimensionality can be handled, including event based data sets
        (even though not all methods do work for these). Any model can
        be assembled for fitting data sets.<br>
        <br>
        For the impatient: See the <b><a href="Install.html">Install</a></b>
        page to download and install the package.<br>
        <div align="center"><img alt="Animated features" title="Animated
            features" src="images/animated.gif" height="420" width="560"><br>
        </div>
        <div align="center"> <i>A gallery of some of the things iFit
            can do</i><br>
        </div>
        <ul>
        </ul>
        <h3><a class="mozTocH3" name="mozTocId969915"></a>Main
          functionalities<br>
        </h3>
        The iFit package constitutes a full data analysis
        infrastructure. To summarize, we list below the most important
        resources you may use:<br>
        <br>
        <table cellspacing="2" cellpadding="2" width="100%" border="1">
          <tbody>
            <tr>
              <td valign="top"><a href="iData.html">iData</a></td>
              <td valign="top">the main container for data sets</td>
            </tr>
            <tr>
              <td valign="top"><a href="Load.html">Load</a></td>
              <td valign="top">how to import data sets into iData
                objects</td>
            </tr>
            <tr>
              <td valign="top"><a href="Plot.html">Plot</a></td>
              <td valign="top">how to plot a data set (1D, 2D, 3D and
                above)</td>
            </tr>
            <tr>
              <td valign="top"><a href="Math.html">Math</a></td>
              <td valign="top">plenty of math to work with data sets</td>
            </tr>
            <tr>
              <td valign="top"><a href="Fit.html">Fit</a></td>
              <td valign="top">how to fit a model onto a data set (using
                an optimizer)<br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="Save.html">Save</a></td>
              <td valign="top">saving data sets<br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="Optimizers.html">Optimization</a></td>
              <td valign="top">routines for optimisation of anything
                (including models)<br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="iFunc.html">iFunc</a></td>
              <td valign="top">the main model object<br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="Loaders.html">File formats</a></td>
              <td valign="top">a list of supported input file formats
                (for data sets and models)<br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="miFit.html">miFit</a></td>
              <td valign="top">the main iFit user interface (for those
                avoiding command lines)<br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="Python.html">PyFit</a></td>
              <td valign="top">using iFit from Python<a
                  href="http://python.org/"><img alt="Python"
                    title="Python" src="images/python-logo.gif"
                    height="34" align="right" width="100" border="0"></a></td>
            </tr>
          </tbody>
        </table>
        <br>
        In addition, we provide some <b>higher level applications</b>:<br>
        <br>
        <table cellspacing="2" cellpadding="2" width="100%" border="1">
          <tbody>
            <tr>
              <td valign="top"><a href="Models.html">Models</a></td>
              <td valign="top">pre-defined models (1D, 2D, 4D)<br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="Neutron_Scattering.html">Neutron
                  Scattering<br>
                </a></td>
              <td valign="top">Neutron scattering data treatment<br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="Models_Phonons.html">Phonons</a></td>
              <td valign="top">lattice dynamics aka phonons<img
                  src="images/Models_sqw_phon.png"
                  title="Models_sqw_phon" alt="Models_sqw_phon"
                  height="59" align="right" width="80"><br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a
                  href="../Applications/ResLibCal/doc/ResLibCal.html">ResLibCal</a></td>
              <td valign="top">Neutron triple-axis spectrometer model,
                resolution and fitting<img
                  src="../Applications/ResLibCal/doc/ResLibCal-logo.png"
                  title="ResLibCal" alt="ResLibCal" height="80"
                  align="right" width="80"><br>
              </td>
            </tr>
            <tr>
              <td valign="top"><a href="McStas.html">McStas</a></td>
              <td valign="top">Monte-Carlo neutron/x-ray ray-tracing
                instrument simulation<img src="images/mcstas.png"
                  title="mcstas" alt="mcstas" height="47" align="right"
                  width="80"><br>
              </td>
            </tr>
          </tbody>
        </table>
        <br>
        The library can be used from <b>user interfaces</b>, or from
        the prompt as a set of commands and scripts.<br>
        <br>
        <table cellspacing="2" cellpadding="2" width="100%" border="1">
          <tbody>
            <tr>
              <td valign="top" align="center">From the prompt (command
                line)<br>
              </td>
              <td valign="top" align="center">User interface: <b><a
                    href="miFit.html">miFit</a></b><br>
              </td>
              <td valign="top" align="center">neutron TAS: <b><a
                    href="../Applications/ResLibCal/doc/ResLibCal.html">ResLibCal</a></b></td>
            </tr>
            <tr>
              <td valign="top" align="center"><img alt="iFit prompt"
                  title="iFit prompt" src="images/iFit_standalone.png"
                  height="99" width="150"><br>
                Have a look at the <a href="QuickStart.html">Quick
                  Start</a> or the <a href="iFit.html">iFit standalone</a>
                page. There, you mostly manipulate <a href="iData.html">iData</a>
                and <a href="iFunc.html">iFunc</a> objects.<br>
              </td>
              <td valign="top" align="center"><a href="miFit.html"><img
                    alt="miFit" title="miFit" src="images/miFit.png"
                    height="121" width="150" border="0"></a><br>
                an advanced yet simple user interface to load data sets,
                plot, transform, export, and fit.<br>
              </td>
              <td valign="top" align="center"><a
                  href="../Applications/ResLibCal/doc/ResLibCal.html"><img
                    alt="ResLibCal" title="ResLibCal"
                    src="../Applications/ResLibCal/doc/ResLibCal.png"
                    height="169" width="150" border="0"></a><br>
                compute the neutron TAS spectrometer resolution
                ellipsoid (ResCal/ResLib merge)<br>
              </td>
            </tr>
          </tbody>
        </table>
        <br>
        Get more details about <a href="InTheBox.html">what's in the
          box</a>.<img src="images/box.jpeg" title="box" alt="box"
          height="100" align="right" width="128"><br>
      </div>
    </div>
    <h3><a class="mozTocH4" name="mozTocId755938"></a><span
        style="font-style: italic; font-weight: bold;">Ok, let's start !</span>
      <br>
    </h3>
    <div style="margin-left: 40px;">To download and install the package,
      refer to the <a href="Install.html">Install</a> page.<br>
      <br>
      We then recommend that you start with the <a href="miFit.html">miFit</a>
      user interface.<br>
      <br>
      If you want a quick example with commands, refer to the <a
        href="QuickStart.html">Quick Start</a> page. Otherwise, the
      typical usage would be:</div>
    <pre style="margin-left: 80px;"><span style="color: rgb(51, 102, 255);"><span style="color: rgb(0, 0, 0);">Start Matlab... or iFit stand-alone<br>&gt;&gt; </span>addpath</span>(<span style="color: rgb(51, 102, 255);">genpath</span>(<span style="color: rgb(204, 51, 204);">'/some/path/to/iFit'</span>)); <span style="font-style: italic;">% not needed for the stand-alone version</span><br><span style="color: rgb(51, 102, 255);"><span style="color: rgb(0, 0, 0);">&gt;&gt; </span></span>a = <span style="color: rgb(51, 102, 255);">iData</span>(<span style="color: rgb(204, 51, 204);">[ ifitpath 'Data/ILL_IN6.dat' ]</span>);<span style="color: rgb(51, 102, 255);"></span><br><span style="color: rgb(51, 102, 255);"><span style="color: rgb(0, 0, 0);">&gt;&gt; </span></span><span style="color: rgb(51, 102, 255);">plot</span>(log10(a))<br><span style="color: rgb(51, 102, 255);"><span style="color: rgb(0, 0, 0);">&gt;&gt; </span></span>b=2*a+<span style="color: rgb(51, 102, 255);">log</span>(a)<br>&gt;&gt; plot(gauss2d)<br><span style="color: rgb(51, 102, 255);"><span style="color: rgb(0, 0, 0);">&gt;&gt; </span></span>parameters=<span style="color: rgb(51, 102, 255);">fits</span>(a,<span style="color: rgb(204, 51, 204);">gauss2d</span>)<br><span style="color: rgb(51, 102, 255);"><span style="color: rgb(0, 0, 0);">&gt;&gt; </span></span><span style="color: rgb(51, 102, 255);">saveas</span>(a,<span style="color: rgb(204, 51, 204);">'filename.</span><span style="color: rgb(204, 51, 204);">pdf'</span>)<br></pre>
    <blockquote>If you wish to reduce the amount of messaging, use:<br>
    </blockquote>
    <blockquote>
      <blockquote>
        <pre><font color="#3366ff">warning</font> on backtrace&nbsp;&nbsp;&nbsp; <i>% </i><i><b>lots</b></i><i> of output, with backtrace for each 'warning'</i></pre>
        <pre><font color="#3366ff">warning</font> off backtrace&nbsp;&nbsp; <i>% normal messages, but no backtrace</i></pre>
        <pre><font color="#3366ff">warning</font> off&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;<i>% minimal output, removes most of the messages but errors</i></pre>
      </blockquote>
    </blockquote>
    <h3><a class="mozTocH3" name="mozTocId639966"></a>For beginners</h3>
    <div style="margin-left: 40px;"><span style="font-weight: bold;
        font-style: italic;">If you do not know Matlab</span> already,
      you will discover that using the iFit library does not require
      advanced IT knowledge. The general syntax are rather intuitive,
      and all methods are able to tolerate (and correct) most of the
      user mistakes. In this respect, when some of the input parameters
      are missing, sensible choices can be made automatically. You can
      look at the <a href="iFit.html">iFit</a> standalone page, where a
      short Matlab introduction is available.<br>
      <br>
      <span style="font-style: italic; font-weight: bold;">If you have
        used in the past the <a
href="https://github.com/simonward86/Mtools/">MFit/MView</a></span>
      suite, you will find that this library has the same scope, but
      omitting the user interface.<br>
      <span style="font-weight: bold; font-style: italic;">If you have
        used the <a
href="https://github.com/simonward86/Mtools/">Spec1d</a>
        object</span>, you will quickly find that the <span
        style="font-style: italic;">iFit</span> follows exactly the same
      syntax.<br>
      <br>
      <span style="font-weight: bold; font-style: italic;">If you come
        from the <a href="http://www.python.org/">Python</a> world</span>,
      you will find out that the iFit syntax is pretty close. We provide
      for you a Python interface to iFit which exposes iFit objects and
      methods into Python. Refer to the <a href="Python.html">PyFit</a>
      page.<br>
    </div>
    <h3><a class="mozTocH3" name="mozTocId66420"></a>Help me !<img
        style="width: 107px; height: 128px;" alt="HELP" title="HELP"
        src="images/help.jpeg" align="right"></h3>
    An extensive documentation is provided as web pages (such as this
    one) which you access from Matlab with either<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">doc</span>(iData)<br>&gt;&gt; <span style="color: rgb(51, 102, 255);">doc</span>(iFunc)<br>&gt;&gt; <span style="color: rgb(51, 102, 255);">methods</span>(iData)<br></pre>
    and help pages for each function/method, which you can access with
    e.g.<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">help</span> iData<br>&gt;&gt; <span style="color: rgb(51, 102, 255);">help</span> iData/load<br>&gt;&gt; <span style="color: rgb(51, 102, 255);">help</span> iFunc<br></pre>
    A <a href="http://ifit.mccode.org/Tutorial">Tutorial</a> (Jan 2012)
    is available as PDF presentations with exercises.<br>
    You may also search this whole documentation (using Google):
    <form method="get" action="http://www.google.com/search"> <input
        name="q" size="31" maxlength="255" type="text"> <input value="Search iFit Doc" type="submit">
      <input name="sitesearch" value="ifit.mccode.org" checked="checked"
        type="radio"> </form>
    Finally, the whole Matlab documentation is available <a
      href="http://www.mathworks.com/help/techdoc/">on-line</a> for
    free, especially to complement the standalone limited help system.<br>
    &nbsp;<br>
    <font color="#ff0000"><b>A list of </b><b>bugs</b><b> and release
        history</b></font> is recorded in the <a href="Changes.html">Changes</a>
    page. <br>
    If you find new bugs please send them to me <span
      style="font-weight: bold;">[ifit-users@mccode.org]</span> with:<br>
    <ol>
      <li>your Matlab version</li>
      <li>the iFit version which you can get from the Matlab command <span
          style="font-style: italic;">version(iData)</span><br>
      </li>
      <li>the script/command that reproduces the error together with any
        required external data file</li>
      <li>a copy of the error messages produced by the script/command.<br>
      </li>
      <li>a smile ;-)</li>
    </ol>
    The <a
      href="http://mailman2.mccode.org/cgi-bin/mailman/listinfo/ifit-users">ifit-users</a>
    is the list set-up in order to exchange information (issues,
    questions, announcements). Messages should be sent to <a
      href="mailto:ifit-users@mccode.org">ifit-users@mccode.org</a>.<br>
    <br>
    You may register by entering your email address and press subscribe:
    <br>
    <form method="POST"
      action="http://mailman2.mccode.org/cgi-bin/mailman/subscribe/ifit-users"><input
        name="email" size="30" type="Text"><input name="email-button" value="Subscribe" type="Submit"></form>
    <br>
    <h3><a class="mozTocH3" name="mozTocId318588"></a>Obtaining the
      package<img src="images/box.jpeg" title="box" alt="box"
        height="100" align="right" width="128"></h3>
    To install the package, refer to the <b><a href="Install.html">Install</a></b>
    page. See the <a href="Changes.html">Changes</a>.<br>
    <br>
    Installation for Linux Debian-class systems is simplified using
    package managers - see <a href="Install.html#mozTocId73823">here</a>.<br>
    When starting from scratch, we recommend installing a <a
      href="https://www.ubuntu.com/download/desktop">Ubuntu</a> system,
    then add package <i>ifit-phonons</i> from our <a
      href="http://packages.mccode.org">Debian repository</a>.<br>
    <br>
    Please register to the <a
      href="http://mailman2.mccode.org/cgi-bin/mailman/listinfo/ifit-users">ifit-users</a>
    mailing list.
    <h3><a class="mozTocH3" name="mozTocId93435"></a>Credits, Links and
      Disclaimer<br>
    </h3>
    <span style="font-style: italic;">iFit</span> was invented by E.
      Farhi</a> and took many years to come to you. <br>
    Substantial contributions from <span style="font-style: italic;">Y.
      Debab</span> and <span style="font-style: italic;">P. Willendrup</span>.<br>
    If you produce scientific output using iFit, I'd appreciate if you
    cite the following reference:<br>
    <ul>
      <li>E. Farhi, Y. Debab and P. Willendrup, <span
          style="font-style: italic;">J. Neut. Res</span>., <span
          style="font-weight: bold;">17</span> (2013) 5. DOI:
        10.3233/JNR-130001
        <style type="text/css">p.sdfootnote { margin-left: 0.5cm; text-indent: -0.5cm; margin-bottom: 0cm; font-size: 10pt; }p { margin-bottom: 0.21cm; }a:link {  }a.sdfootnoteanc { font-size: 57%; }</style></li>
      <li>E. Farhi, <span style="font-style: italic;">The iFit data
          analysis library</span>, Synchrotron-Soleil &lt;<a href="http://ifit.mccode.org/">http://ifit.mccode.org</a>&gt;.</li>
    </ul>
    iFit is a product from the ILL (2007-2019) and Synchrotron-Soleil (2019-), France.<br>
    <br>
    See the <a href="Credits.html">Credits</a> page for more
    information on contributions, including <a href="../COPYING">licensing</a>.
    <br>
    A set of <a href="Credits.html#mozTocId694411">links</a> to related
    packages is also included there.<br>
    <br>
    <i><b>If you wish to contribut</b></i><i><b>e</b></i>, send
    suggestions, scripts, and new functions/methods to <span
      style="font-weight: bold;">[ifit-users@mccode.org]</span>. Your
    contribution will then be included in the next release, with proper
    credits to the authors. <br>
    <br>
    An other solution is to use the GitHub 'pull request' mechanism,
    i.e. login at <a href="https://gitlab.com">GitHub</a>, <a
      href="https://gitlab.com/soleil-data-treatment/soleil-software-projects/ifit/-/forks/new">fork


      your own iFit</a> repository, modify it at your convenience, and
    then <a
      href="https://gitlab.com/soleil-data-treatment/soleil-software-projects/ifit/-/merge_requests/new">mark
      changes for inclusion</a> back into the master iFit branch as a Merge Request (MR). These
    changes will then eventually be validated, and inserted into the
    project.<br>
    <br>
    <span style="color: rgb(255, 0, 0); font-weight: bold;">Disclaimer:</span><br>
    This software is experimental, and should not be considered
    bullet-proof. In particular, expect many bugs - which should be
    reported to me <span style="font-weight: bold;">[ifit-users@mccode.org]</span>
    or as an <a href="https://gitlab.com/soleil-data-treatment/soleil-software-projects/ifit/-/issues">'issue'

      on GitHub</a> if you want them to be fixed quickly. Also, this
    prototype is known to be slow. This will be improved gradually...<br>
    <br>
    <hr style="width: 100%; height: 2px;">
    <div style="text-align: center;"><span style="font-style: italic;">E.
Farhi










        - iFit Welcome - $Date$ $Revision$ $Author$</span> - back to <a
        href="index.html">Main iFit Page</a> </div>
  </body>
</html>
